## esdm 1.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

#
# PROJECT METADATA
# _____________________________________________________________________________

set(PROJECT_NAME esdm)
project(${PROJECT_NAME} C)

set(VERSION_MAJOR "0")
set(VERSION_MINOR "1")
set(VERSION_PATCH "0")
set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

include(CTest)
include(FeatureSummary)
include(CheckCSourceCompiles)

# set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)

#
# USEFUL PROJECT VARIABLES
# _____________________________________________________________________________

set(DEV_DIR "${CMAKE_SOURCE_DIR}/dev")
set(DOC_DIR "${CMAKE_SOURCE_DIR}/doc")
set(DEPS_DIR "${CMAKE_SOURCE_DIR}/deps")


# CMake useful variables
#set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
#set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
#set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")

#
# BUILD SETTINGS
# _____________________________________________________________________________




set(CMAKE_C_FLAGS_DEBUG "-O0 -g3 -D__FILENAME__='\"$(subst ${CMAKE_SOURCE_DIR}/,,$(abspath $<))\"'" CACHE STRING "C Debug Compiler Flags" FORCE)
set(CMAKE_C_FLAGS_RELEASE "-DDEBUG_OFF -O3 -D__FILENAME__='\"$(subst ${CMAKE_SOURCE_DIR}/,,$(abspath $<))\"'" CACHE STRING "C Release Compiler Flags" FORCE)

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11 -pedantic -Wall -Wdouble-promotion -Wfloat-equal -flto -fdata-sections -ffunction-sections -Wl,--gc-sections -Wl,--allow-shlib-undefined -Wl,--retain-symbols-file=${CMAKE_SOURCE_DIR}/dev/symbols.txt")
#-fvisibility=hidden -fvisibility-inlines-hidden


#
# CNAKE MODULES & DEPENDENCIES
# _____________________________________________________________________________


find_package(PkgConfig REQUIRED)


# For documentation (optional)
find_package(Doxygen)
if(DOXYGEN_FOUND)
    add_custom_target(doc
        ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating API documentation with Doxygen" VERBATIM
    )

    #find_package( Java )
    # add_feature_info( Java DESCRIPTION "Java is needed in the documentation to run Plantuml" TYPE OPTIONAL)
    #if(JAVA_FOUND)
      find_path (PLANTUML_JAR_PATH plantuml.jar HINTS "/usr/share/java/" ${DEPS_DIR} . ${DEV_DIR} DOC "PLANTUML directory" ENV PLANTUML_JAR_PATH)
      if(PLANTUML_JAR_PATH)
        set(PLANTUML_JAR_PATH "${PLANTUML_JAR_PATH}/plantuml.jar")
        set(PLANTUML_ON ON)
      else()
        message(STATUS "Warning: plantuml.jar not found.")
      endif()
    #endif(JAVA_FOUND)
    configure_file(${DOC_DIR}/Doxyfile.in Doxyfile @ONLY)
endif(DOXYGEN_FOUND)

option(plantuml "Plantuml support" ${PLANTUML_ON})
add_feature_info(plantuml plantuml  "PlantUML for documentation" URL http://de.plantuml.com/ TYPE OPTIONAL)



#
# OTHER
# _____________________________________________________________________________



enable_testing()

add_subdirectory(deps)
add_subdirectory(src)


feature_summary(WHAT ALL)

=== deps/CMakeLists.txt ===
# https://www.selectiveintellect.net/blog/2016/7/29/using-cmake-to-add-third-party-libraries-to-your-project-1

#include(CheckIncludeFiles)
#include(ExternalProject)
#include(smd.cmake)

add_subdirectory(smd)

SET(SMD_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/smd/include CACHE PATH "SMD INCLUDES")

=== src/CMakeLists.txt ===
pkg_search_module(GLIB REQUIRED glib-2.0>=2.40)
set_package_properties(GLIB PROPERTIES
	DESCRIPTION "Implementation of common data structures, portability wrappers for standard OS features."
	URL "http://www.gtk.org"
	TYPE REQUIRED
	PURPOSE "Support for hash maps and tree data structures."
)

pkg_search_module(JANSSON REQUIRED jansson)
set_package_properties(JANSSON PROPERTIES
	DESCRIPTION "Library for encoding, decoding and manipulating JSON."
	URL "http://www.digip.org/jansson/"
	TYPE REQUIRED
	PURPOSE "Support for JSON metadata description."
)
include_directories(${JANSSON_INCLUDE_DIRS})

pkg_search_module(SCIL scil)
set_package_properties(SCIL PROPERTIES
	DESCRIPTION "Library for compression."
	URL "https://github.com/JulianKunkel/scil"
	TYPE OPTIONAL
	PURPOSE "Support for SCIL compression."
)

find_package (Threads)

# Optional
find_package(MPI REQUIRED) # TODO this is optional


# Threading support
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

set(CMAKE_MACOSX_RPATH 1)
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib:${GLIB_LIBRARY_DIRS}:${JANSSON_LIBRARY_DIRS}:${SCIL_LIBRARY_DIRS}")





#
# Verbose debugging information for required software dependencies
# _____________________________________________________________________________

message(STATUS "GLIB_FOUND   ${GLIB_FOUND}")
message(STATUS "GLIB_LIBRARIES   ${GLIB_LIBRARIES}")
message(STATUS "GLIB_LIBRARY_DIRS   ${GLIB_LIBRARY_DIRS}")
message(STATUS "GLIB_LDFLAGS   ${GLIB_LDFLAGS}")
message(STATUS "GLIB_LDFLAGS_OTHER   ${GLIB_LDFLAGS_OTHER}")
message(STATUS "GLIB_INCLUDE_DIRS   ${GLIB_INCLUDE_DIRS}")
message(STATUS "GLIB_CFLAGS   ${GLIB_CFLAGS}")
message(STATUS "GLIB_CFLAGS_OTHER   ${GLIB_CFLAGS_OTHER}")

message(STATUS "JANSSON_FOUND   ${JANSSON_FOUND}")
message(STATUS "JANSSON_LIBRARIES   ${JANSSON_LIBRARIES}")
message(STATUS "JANSSON_LIBRARY_DIRS   ${JANSSON_LIBRARY_DIRS}")
message(STATUS "JANSSON_LDFLAGS   ${JANSSON_LDFLAGS}")
message(STATUS "JANSSON_LDFLAGS_OTHER   ${JANSSON_LDFLAGS_OTHER}")
message(STATUS "JANSSON_INCLUDE_DIRS   ${JANSSON_INCLUDE_DIRS}")
message(STATUS "JANSSON_CFLAGS   ${JANSSON_CFLAGS}")
message(STATUS "JANSSON_CFLAGS_OTHER   ${JANSSON_CFLAGS_OTHER}")

if(SCIL_FOUND)
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_SCIL ${SCIL_CFLAGS}")
endif(SCIL_FOUND)

message(STATUS "SCIL_FOUND   ${SCIL_FOUND}")
message(STATUS "SCIL_LIBRARIES   ${SCIL_LIBRARIES}")
message(STATUS "SCIL_LIBRARY_DIRS   ${SCIL_LIBRARY_DIRS}")
message(STATUS "SCIL_LDFLAGS   ${SCIL_LDFLAGS}")
message(STATUS "SCIL_LDFLAGS_OTHER   ${SCIL_LDFLAGS_OTHER}")
message(STATUS "SCIL_INCLUDE_DIRS   ${SCIL_INCLUDE_DIRS}")
message(STATUS "SCIL_CFLAGS   ${SCIL_CFLAGS}")
message(STATUS "SCIL_CFLAGS_OTHER   ${SCIL_CFLAGS_OTHER}")








#
# OPTIONS
# _____________________________________________________________________________

# General Options
option(ENABLE_MPI "Compile with MPI Support?" OFF)

# Frontends
option(ENABLE_HDF5 "Compile Plugin for HDF5 Virtual Object Layer?" OFF)

#
# TARGETS
# _____________________________________________________________________________

set(ESDM_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/src/include;${GLIB_INCLUDE_DIRS};${JANSSON_INCLUDE_DIRS};${SMD_INCLUDES}")
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/)

add_subdirectory(backends-metadata)
add_subdirectory(utils)
add_subdirectory(test)
add_subdirectory(tools)




# Include directories for all target in this CMakeLists.txt
include_directories(${CMAKE_BINARY_DIR} ${ESDM_INCLUDE_DIRS} ${GLIB_INCLUDE_DIRS} ${JANSSON_INCLUDE_DIRS} ${SMD_INCLUDES} ${SCIL_INCLUDE_DIRS})


# ESDM Middleware Library
add_library(esdm SHARED esdm.c esdm-scheduler.c esdm-stream.c fragments.c esdm-modules.c backends-data/init.c estream.c esdm-attributes.c esdm-datatypes.c esdm-layout.c esdm-performancemodel.c esdm-config.c performance.c hypercube.c hypercube-neighbour-manager.c esdm-grid.c utils/debug.c utils/auxiliary.c)
target_link_libraries(esdm ${GLIB_LDFLAGS} ${JANSSON_LDFLAGS} ${SCIL_LDFLAGS} ${CMAKE_THREAD_LIBS_INIT} esdmdummy esdm-mdposix smd m)
if(BACKEND_MONGODB)
    target_link_libraries(esdm esdmmongodb)
endif()


#target_compile_definitions(esdm PRIVATE MYDEF=${MYVAR})       # TODO: replace backend/feature enablers with this mechanism
#target_include_directories(esdm PUBLIC include PRIVATE src)   # TODO: decide on main-project/sub-project structure and switch away from include_directories directive where possible

install(TARGETS esdm LIBRARY DESTINATION lib)
install(FILES "./include/esdm-datatypes.h" DESTINATION include)
install(FILES "./include/esdm.h" DESTINATION include)
install(FILES "./include/esdm-stream.h" DESTINATION include)
install(FILES "./include/esdm-mpi.h" DESTINATION include)

SUBDIRS(interfaces)



### Data backends ###
SUBDIRS(backends-data/dummy)

option(BACKEND_S3 "Compile backend for S3 support?" OFF)
if(BACKEND_S3)
	message(STATUS "WITH_BACKEND_S3")
	add_definitions(-DESDM_HAS_S3=1)
	SUBDIRS(backends-data/s3)

  find_path(S3_INCLUDE_DIR libs3.h HINTS ${S3_INCLUDE_DIR})
  find_library(S3_LIBRARY NAMES s3 HINTS ${S3_LIB_DIR})

  target_link_libraries(esdm esdms3)
endif()

option(BACKEND_POSIX "Compile backend for POSIX support?" ON)
if(BACKEND_POSIX)
	message(STATUS "WITH_BACKEND_POSIX")
	add_definitions(-DESDM_HAS_POSIX=1)
	SUBDIRS(backends-data/posix)
  target_link_libraries(esdm esdmposix)
endif()


option(BACKEND_LUSTRE "Compile backend for Lustre support?" OFF)
if(BACKEND_LUSTRE)
	message(STATUS "WITH_BACKEND_LUSTRE")
	add_definitions(-DESDM_HAS_LUSTRE=1)
	SUBDIRS(backends-data/lustre)
endif()

option(BACKEND_CLOVIS "Compile backend for Clovis support?" OFF)
if(BACKEND_CLOVIS)
	message(STATUS "WITH_BACKEND_CLOVIS")
	add_definitions(-DESDM_HAS_CLOVIS=1)
  target_link_libraries(esdm esdmclovis)
	SUBDIRS(backends-data/Clovis)
endif()

option(BACKEND_WOS "Compile backend for WOS support?" OFF)
if(BACKEND_WOS)
	message(STATUS "WITH_BACKEND_WOS")
	add_definitions(-DESDM_HAS_WOS=1)
  target_link_libraries(esdm esdmwos)
	SUBDIRS(backends-data/WOS)
endif()


option(BACKEND_KDSA "Compile backend for Kove XPD / KDSA API" OFF)
option(BACKEND_KDSA_DUMMY "Compile dummy file backend for Kove XPD / KDSA API" OFF)

message(STATUS "Searching for KDSA libraries")
find_path(KDSA_INCLUDE_DIR kdsa.h HINTS ${KDSA_INCLUDE_DIR})
find_library(KDSA_LIBRARY NAMES kdsa HINTS ${KDSA_LIB_DIR})
string(COMPARE EQUAL "${KDSA_LIBRARY}" KDSA_LIBRARY-NOTFOUND _cmp)
if(_cmp)
  message("not found")
else()
  message(STATUS "found in ${KDSA_LIBRARY} and ${KDSA_INCLUDE_DIR}")
  set(BACKEND_KDSA ON)
endif()
if(BACKEND_KDSA OR BACKEND_KDSA_DUMMY)
	message(STATUS "WITH_BACKEND_KDSA")
	add_definitions(-DESDM_HAS_KDSA=1)
  target_link_libraries(esdm esdmkdsa)
	SUBDIRS(backends-data/kdsa)
endif()

message(STATUS "Searching for IME libraries")
option(BACKEND_IME "Compile backend for IME" OFF)
find_path(IME_INCLUDE_DIR ime_native.h HINTS ${IME_INCLUDE_DIR})
find_library(IME_LIBRARY NAMES im_client HINTS ${IME_LIB_DIR})
string(COMPARE EQUAL "${IME_LIBRARY}" IME_LIBRARY-NOTFOUND _cmp)
if(_cmp)
  message("not found")
else()
  message(STATUS "found in ${IME_LIBRARY} and ${IME_INCLUDE_DIR}")
  set(BACKEND_IME ON)
endif()
if(BACKEND_IME)
	message(STATUS "WITH_BACKEND_IME")
	add_definitions(-DESDM_HAS_IME=1)
  target_link_libraries(esdm esdmime ${IME_LIBRARY})
	SUBDIRS(backends-data/ime)
endif()


message(STATUS "Searching for PMEM libraries")

option(BACKEND_PMEM "Compile backend for PMEM" OFF)

find_path(PMEM_INCLUDE_DIR libpmem.h HINTS ${PMEM_INCLUDE_DIR})
find_library(PMEM_LIBRARY NAMES pmem HINTS ${PMEM_LIB_DIR})
string(COMPARE EQUAL "${PMEM_LIBRARY}" PMEM_LIBRARY-NOTFOUND _cmp)
if(_cmp)
  message("not found")
else()
  message(STATUS "found in ${PMEM_LIBRARY} and ${PMEM_INCLUDE_DIR}")
  set(BACKEND_PMEM ON)
endif()

if(BACKEND_PMEM)
	message(STATUS "WITH_BACKEND_PMEM")
	add_definitions(-DESDM_HAS_PMEM=1)

  SUBDIRS(backends-data/pmem)
  target_link_libraries(esdm esdmpmem)
endif()

### END Data backends ###


#
# INSTALL & SYSTEM PACKAGING (RPM, TGZ, ...)
# _____________________________________________________________________________


# System Packaging
#include(CPackConfig)

=== deps/smd/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

#
# PROJECT METADATA
# _____________________________________________________________________________

set(PROJECT_NAME smd)
project(${PROJECT_NAME} C)

set(VERSION_MAJOR "0")
set(VERSION_MINOR "1")
set(VERSION_PATCH "0")
set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})


#
# USEFUL PROJECT VARIABLES
# _____________________________________________________________________________

set(DEV_DIR "${CMAKE_SOURCE_DIR}/dev")
set(DOC_DIR "${CMAKE_SOURCE_DIR}/doc")
set(DEPS_DIR "${CMAKE_SOURCE_DIR}/deps")


# CMake useful variables
#set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
#set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
#set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")




#
# BUILD SETTINGS
# _____________________________________________________________________________

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11 -pedantic -Wall -Wdouble-promotion -Wfloat-equal -flto -fdata-sections -ffunction-sections -Wl,--gc-sections -Wl,--allow-shlib-undefined -pedantic-errors") #
# -Wl,--retain-symbols-file=${CMAKE_SOURCE_DIR}/dev/symbols.txt

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wall -Wextra -Wdouble-promotion -Wfloat-equal -flto -fdata-sections -ffunction-sections -Wl,--gc-sections -Wl,--allow-shlib-undefined -pedantic-errors")

set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -g3")
set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3")

set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -g3")
set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3")


#
# CNAKE MODULES & DEPENDENCIES
# _____________________________________________________________________________

include(CTest)
include(FeatureSummary)
include(CheckCSourceCompiles)

find_package(PkgConfig REQUIRED)

# For documentation (optional)
find_package(Doxygen)
if(DOXYGEN_FOUND)
    add_custom_target(doc-${PROJECT_NAME}
        ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating API documentation with Doxygen" VERBATIM
    )

    #find_package( Java )
    # add_feature_info( Java DESCRIPTION "Java is needed in the documentation to run Plantuml" TYPE OPTIONAL)
    #if(JAVA_FOUND)
      find_path (PLANTUML_JAR_PATH plantuml.jar HINTS "/usr/share/java/" ${DEPS_DIR} . ${DEV_DIR} DOC "PLANTUML directory" ENV PLANTUML_JAR_PATH)
      if(PLANTUML_JAR_PATH)
        set(PLANTUML_JAR_PATH "${PLANTUML_JAR_PATH}/plantuml.jar")
        set(PLANTUML_ON ON)
      else()
        message(STATUS "Warning: plantuml.jar not found.")
      endif()
    #endif(JAVA_FOUND)
    configure_file(${DOC_DIR}/Doxyfile.in Doxyfile @ONLY)
endif(DOXYGEN_FOUND)

option(plantuml "Plantuml support" ${PLANTUML_ON})
add_feature_info(plantuml plantuml  "PlantUML for documentation" URL http://de.plantuml.com/ TYPE OPTIONAL)

#
# OTHER
# _____________________________________________________________________________

enable_testing()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)

add_subdirectory(src)
add_subdirectory(test)
install(FILES "./include/smd-datatype.h" DESTINATION include)
install(FILES "./include/smd.h" DESTINATION include)

feature_summary(WHAT ALL)

=== src/backends-metadata/CMakeLists.txt ===
SUBDIRS(posix)

# Metadata Backends
option(BACKEND_MONGODB "Compile metadata backend for MongoDB support?" OFF)
if(BACKEND_MONGODB)
	message(STATUS "WITH_BACKEND_MONGODB")
	add_definitions(-DESDM_HAS_MONGODB=1)
	SUBDIRS(mongodb)
endif()

=== src/interfaces/CMakeLists.txt ===

# Data Backends
option(INTERFACE_HDF5 "Compile interface for HDF5 support?" OFF)
if(INTERFACE_HDF5)
	message(STATUS "WITH_INTERFACE_HDF5")
	add_definitions(-DESDM_HAS_HDF5=1)
	SUBDIRS(hdf5)
endif()

option(INTERFACE_NETCDF4 "Compile interface for NETCDF support?" OFF)
if(INTERFACE_NETCDF4)
	message(STATUS "WITH_INTERFACE_NETCDF4")
	add_definitions(-DESDM_HAS_NETCDF=1)
	SUBDIRS(netcdf)
endif()

#option(INTERFACE_MPI "Compile interface for MPI support?" ON)
#if(INTERFACE_MPI)
#	message(STATUS "WITH_INTERFACE_MPI")
#	add_definitions(-DINTERFACE_MPI=1)
	SUBDIRS(mpi)
#endif()

=== src/test/CMakeLists.txt ===
#
# Tests
# _____________________________________________________________________________

# Copy some prepared files such as a ESDM configuration to the build test directory
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/esdm.conf DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/esdm-posix.conf DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/esdm-wos.conf DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/esdm-clovis.conf DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/esdm-mixed.conf DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/cleanup.sh DESTINATION ${CMAKE_CURRENT_BINARY_DIR})



# Generic tests, that only require libesdm
file(GLOB TESTFILES "${CMAKE_CURRENT_SOURCE_DIR}" "*.c")
foreach(TESTFILE ${TESTFILES})
  if(IS_DIRECTORY ${TESTFILE} )
    #message(STATUS ${TESTFILE})
  else()
    get_filename_component(TESTNAME_C ${TESTFILE} NAME)
    STRING(REGEX REPLACE ".c$" "" TESTNAME ${TESTNAME_C})

	# Build, link and add as test
    add_executable(${TESTNAME} ${TESTFILE} util/test_util.c)
   	target_link_libraries(${TESTNAME} esdm esdmmpi -lrt)
    target_include_directories(${TESTNAME} PRIVATE ${ESDM_INCLUDE_DIRS} ${MPI_INCLUDE_PATH} ${CMAKE_BINARY_DIR} ${GLIB_INCLUDE_DIRS} ${SMD_INCLUDES})

    add_test(${TESTNAME} ./${TESTNAME})
  endif()
endforeach()

set_tests_properties(fragment-selection-benchmark PROPERTIES WILL_FAIL TRUE)



# A special test with additional requirements
#add_executable(${TESTNAME} ${TESTFILE})
#target_link_libraries(${TESTNAME} "${PROJECT_BINARY_DIR}/libesdm.so" "libspecial.so")
#add_test(${TESTNAME} ./${TESTNAME})

=== src/tools/CMakeLists.txt ===
add_executable(mkfs.esdm mkfs.esdm.c option.c)
target_link_libraries(mkfs.esdm esdm ${MPI_LIBRARIES} -lrt)
target_include_directories(mkfs.esdm SYSTEM PRIVATE ${MPI_INCLUDE_PATH} ${CMAKE_BINARY_DIR} ${ESDM_INCLUDE_DIRS} ${GLIB_INCLUDE_DIRS})
install(TARGETS mkfs.esdm RUNTIME DESTINATION bin)

add_executable(esdm-rm esdm-rm.c option.c tool-util.c)
target_link_libraries(esdm-rm esdm ${MPI_LIBRARIES} -lrt)
target_include_directories(esdm-rm SYSTEM PRIVATE ${MPI_INCLUDE_PATH} ${CMAKE_BINARY_DIR} ${ESDM_INCLUDE_DIRS} ${GLIB_INCLUDE_DIRS})
install(TARGETS esdm-rm RUNTIME DESTINATION bin)

=== src/utils/CMakeLists.txt ===
#add_library(esdm SHARED esdm-datatypes.c  esdm-layout.c  esdm-performancemodel.c  esdm-scheduler.c  esdm-siteconfiguration.c)
#target_link_libraries(esdm ${GLIB_LIBRARIES})
#link_directories(esdm ${GLIB_LIBRARIES})
#include_directories(${CMAKE_SOURCE_DIR}/include/ ${CMAKE_BINARY_DIR} ${GLIB_INCLUDE_DIRS})

## Installation
#install(TARGETS h5-memvol LIBRARY DESTINATION lib)

=== deps/smd/src/CMakeLists.txt ===
set(CMAKE_MACOSX_RPATH 1)
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")


include_directories(${CMAKE_CURRENT_SOURCE_DIR}/)

# ESDM Utils and Database Library

add_library(smd SHARED smd-core.c smd-datatype.c)
target_link_libraries(smd m)
install(TARGETS smd LIBRARY DESTINATION lib)

=== deps/smd/test/CMakeLists.txt ===

# Generic tests, that only require libsmd
file(GLOB TESTFILES "${CMAKE_CURRENT_SOURCE_DIR}" "*.c")
foreach(TESTFILE ${TESTFILES})
  if(IS_DIRECTORY ${TESTFILE} )
    #message(STATUS ${TESTFILE})
  else()
    get_filename_component(TESTNAME_C ${TESTFILE} NAME)
    STRING(REGEX REPLACE ".c$" "" TESTNAME ${TESTNAME_C})

	# Build, link and add as test
    add_executable(${TESTNAME} ${TESTFILE})
   	target_link_libraries(${TESTNAME} smd ${MPI_LIBRARIES} -lrt)
    #target_include_directories(${TESTNAME} SYSTEM PRIVATE ${CMAKE_BINARY_DIR})

    add_test(${TESTNAME} ./${TESTNAME})
  endif()
endforeach()

=== doc/assets/architecture/Makefile ===
SOURCES = $(wildcard *.dot)
OBJECTS = $(SOURCES:.dot=.pdf)

all: $(OBJECTS) Makefile

%.pdf: %.dot
	dot -Tpdf $< -o $@.tmp
	pdfcrop $@.tmp $@
	rm $@.tmp

clean:
	rm $(OBJECTS)

=== debian/changelog ===
esdm (1.0-2) experimental; urgency=medium

  * Add cmake as build-dep. Closes: #1008148

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 23 Mar 2022 10:30:43 +0000

esdm (1.0-1) experimental; urgency=medium

  * Initial release. (Closes: #969088)
    - Add minimal support for /etc/esdm/esdm.conf; examples
  * Resubmit to NEW; src/deps has MIT license

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 23 Feb 2022 12:46:13 +0100

=== debian/control ===
Source: esdm
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
 dh-buildinfo, 
 chrpath,
 cmake,
 libglib2.0-dev,
 libhdf5-mpi-dev (>= 1.12.0+repack-1~exp2),
 pkg-config,
 mpi-default-dev,
 libjansson-dev,
 libs3-dev,
 libpmem-dev,
 libtool,
 libtool-bin,
 doxygen,
 plantuml
Standards-Version: 4.6.0
Homepage: https://github.com/ESiWACE/esdm
Vcs-Browser: https://salsa.debian.org:/science-team/esdm.git
Vcs-Git: https://salsa.debian.org:/science-team/esdm.git -b debian/latest

Package: esdm-tools
Architecture: any
Depends: libesdm0d (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Earth System Data  Middleware
 Climate Data Operators are a collection of command line Operators 
 to manipulate and analyse Climate model Data.  Supported data formats are GRIB, 
 netCDF, SERVICE, EXTRA and IEG. There are more than 400 operators available.

Package: libesdm0d
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Earth System Data  Middleware - libraries
 Climate Data Operators are a collection of command line Operators 
 to manipulate and analyse Climate model Data.  Supported data formats are GRIB, 
 netCDF, SERVICE, EXTRA and IEG. There are more than 400 operators available.

Package: libesdm-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libesdm0d (= ${binary:Version})
Description: Earth System Data  Middleware - devel files
 Climate Data Operators are a collection of command line Operators 
 to manipulate and analyse Climate model Data.  Supported data formats are GRIB, 
 netCDF, SERVICE, EXTRA and IEG. There are more than 400 operators available.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/mpi-default-dev/debian_defaults

HDF5_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/$(ARCH_DEFAULT_MPI_IMPL)

# TODO:
# S3 doesn't compile right now : needs updating in Debian

BUILD_FLAGS = \
	-DPLANTUML_JAR_PATH=/usr/share/plantuml \
	-DBACKEND_KDSA_DUMMY=On \
	-DBACKEND_PMEM=On \
	-DBACKEND_S3=Off \
	-DENABLE_HDF5=On \
	-DENABLE_MPI=On \
	-DBACKEND_POSIX=On

%:
	dh $@ --buildsystem=cmake --builddirectory=debian/build

override_dh_auto_configure:
	dh_auto_configure -- ${BUILD_FLAGS} 


override_dh_auto_test:
	dh_auto_test || echo "Ignoring test failures"

override_dh_auto_build:
	dh_auto_build
	cd debian/build && doxygen

override_dh_auto_install:
	dh_auto_install
	chrpath -d debian/tmp/usr/lib/*.so debian/tmp/usr/bin/*
